/*
 *	plugins.c
 */

#include "filer.h"
#include <dma.h>

static const u8	bGBAHeader[] = {
	0x2e, 0x00, 0x00, 0xea, 0x24, 0xff, 0xae, 0x51,
	0x69, 0x9a, 0xa2, 0x21, 0x3d, 0x84, 0x82, 0x0a,
};

/*
 *	IsPlugin
 */
static BOOL IsPlugin(u8 *pb)
{
	return memcmp(pb, bGBAHeader, sizeof bGBAHeader) == 0;
}

/*
 *	RunPlugin
 */
BOOL RunPlugin(PDIRENT pdir, PDIRENT pfile)
{
	u8	*ppi;
	int	npi;
	void	(*pfunc)();

	ppi = &pfile->fileaddr[pfile->namesize];
	if (!IsPlugin(ppi))
		return FALSE;

	npi = pfile->filesize;
	if (npi > EWRAM_SIZE)
		return FALSE;

	MemCopy16DMA3((void*)ppi, EWRAM_ADDR, npi);

	while ((READ_REG16(REG_DM3CNT_H) & 0x8000)!=0);	// wait for complete

	SetScrnColor(COLOR_WHITE, COLOR_BLACK);
	ClearScrn();

	pfunc = (void (*)())ppi;
	(*pfunc)(); // run!
	// NOTREACHED

	return TRUE;
}

