/*
 *	scrnobj.c
 */

#include <scrn.h>

/*
 *	iwHorPosToVram
 */
static
attriwram
vu16 *iwHorPosToVram(int x, int y)
{
	return (vu16 *)VRAM_ADDR + x + y * SCREEN_WIDTH;
}

/*
 *	iwVrRPosToVram
 */
static
attriwram
vu16 *iwVrRPosToVram(int x, int y)
{
	return (vu16 *)VRAM_ADDR + x * SCREEN_WIDTH + ((SCREEN_WIDTH-1) - y);
}

/*
 *	iwVrLPosToVram
 */
static
attriwram
vu16 *iwVrLPosToVram(int x, int y)
{
	return (vu16 *)VRAM_ADDR + ((SCREEN_HEIGHT-1) - x) * SCREEN_WIDTH + y;
}

/*
 *	ScrnObj
 */

static const SCRNOBJ	ScrnObj[] = {
	{ iwHorPosToVram, 1, SCREEN_WIDTH, SCREEN_WIDTH, SCREEN_HEIGHT },
	{ iwVrRPosToVram, SCREEN_WIDTH, -1, SCREEN_HEIGHT, SCREEN_WIDTH },
	{ iwVrLPosToVram, -SCREEN_WIDTH, 1, SCREEN_HEIGHT, SCREEN_WIDTH },
};

#define nScrnObj	arraysizeof(ScrnObj)

static PSCRNOBJ		pcurso;

/*
 *	SetScrnMode
 */
int SetScrnMode(int mode)
{
	int		omode;

	omode = pcurso - ScrnObj;
	pcurso = (PSCRNOBJ)&ScrnObj[mode];

	return omode;
}

/*
 *	GetScrnMode
 */
int GetScrnMode()
{
	return pcurso - ScrnObj;
}

/*
 *	iwGetScrnObject
 */
attriwram
PSCRNOBJ iwGetScrnObject()
{
	return pcurso;
}

